var options = {};
var once = true;
var v;
var source;

var streamingURL;
var MediaOption;
var CONFIGURATION_FILENAME = 'streaming_conf.json';
var storage = new Storage();
var streamingModeFilename = 'streamingMode'

function init() {
    v = document.getElementById("myVideo");
    source = document.createElement("source");
    load();
}

function load() {
    readConfigurations();
}

function play() {
    var udp = document.getElementById('udp').checked;
    var rtsp = document.getElementById('rtsp').checked;
    // var streamingURL = document.getElementById('url').value;
    var currentConfiguration = {
        mode: '',
        url: '',
        fullPath: ''
    }

    if (udp == true) {
        options.mediaTransportType = "UDP";
        currentConfiguration.mode = 'udp';
        currentConfiguration.fullPath = 'udp://' + document.getElementById('url').value;
    }
    else if (rtsp == true) {
        options.mediaTransportType = "RTSP";
        currentConfiguration.mode = 'rtsp';
        currentConfiguration.fullPath = 'rtsp://' + document.getElementById('url').value;
    }
    else {
        options.mediaTransportType = "RTP";
        currentConfiguration.mode = 'rtp';
        currentConfiguration.fullPath = 'rtp://' + document.getElementById('url').value;
    }
    currentConfiguration.url = document.getElementById('url').value;

    /////////////////////////////////////////////////////////////////
    // Save current configuration to internal memory using SCAP API

    writeFile(CONFIGURATION_FILENAME, JSON.stringify(currentConfiguration),
        function () {
            MediaOption = escape(JSON.stringify(options));
            playWithURI(true, currentConfiguration.fullPath, MediaOption);
        },
        function (err) {
            console.error('[' + err.errorCode + ']' + err.errorText);
        }
    );
    /////////////////////////////////////////////////////////////////
}

function playWithURI(loop, uri, mediaOption) {
    if (once == true) {
        source.setAttribute('src', uri);
        source.setAttribute('type', 'video/mp4;mediaOption=' + mediaOption);
        v.appendChild(source);
        v.loop = loop;
        v.load();
        v.play();
        console.log('video Play!!!!!!!!!');
        once = false;
    }
    else {
        source.setAttribute('src', uri);
        source.setAttribute('type', 'video/mp4;mediaOption=' + mediaOption);
        v.loop = loop;
        v.load();
        v.play();
    }
}


function readConfigurations() {
    var streamingModeSuccessCb = function (streamingCbObject) {
        var data = JSON.parse(streamingCbObject.data)
        var streamingModeData = data.mode;
        var mode = ['udp', 'rtp', 'rtsp'];
        for (var i = 0; i < mode.length; i++) {
            if (mode[i] === streamingModeData)
                document.getElementById(mode[i]).checked = true;
            else {
                document.getElementById(mode[i]).checked = false;
            }
        }
        document.getElementById('url').value = data.url;
        play();
    }

    var failureCb = function (cbObject) {
        var errorCode = cbObject.errorCode;
        var errorText = cbObject.errorText;
        console.error(" Error Code [" + errorCode + "]: " + errorText);
    };

    var streamingModeOptions = {
        path: 'file://internal/' + CONFIGURATION_FILENAME,
        position: 0,
        encoding: 'utf8'
    }
    // Read configuration file
    storage.readFile(streamingModeSuccessCb, failureCb, streamingModeOptions);
}



function writeFile(filename, textData, successCb, failureCb) {
    var filepath = 'file://internal/' + filename;

    // write Text data, use utf-8 encoding, write all text.
    var options = {
        data: textData,
        path: filepath,
        mode: 'truncate',
        encoding: 'utf8'
    };
    storage.writeFile(successCb, failureCb, options);
}
